diff --git a/src/dblib/unittests/t0007.c b/src/dblib/unittests/t0007.c
index f82cc7e..01e0f60 100644
--- a/src/dblib/unittests/t0007.c
+++ b/src/dblib/unittests/t0007.c
@@ -5,21 +5,16 @@
 
 #include "common.h"
 
-
-static char software_version[] = "$Id: t0007.c,v 1.18 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0007.c,v 1.19 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-
-
 static void
 create_tables(DBPROCESS * dbproc, int rows_to_add)
 {
 	int i;
-	char cmd[1024];
-
 
 	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib0007 (i int not null, s char(12) not null)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -27,24 +22,21 @@ create_tables(DBPROCESS * dbproc, int rows_to_add)
 
 	fprintf(stdout, "insert\n");
 	for (i = 1; i < rows_to_add; i++) {
-		sprintf(cmd, "insert into #dblib0007 values (%d, 'row %07d')", i, i);
-		fprintf(stdout, "%s\n", cmd);
-		dbcmd(dbproc, cmd);
+		sql_cmd(dbproc, INPUT);
 		dbsqlexec(dbproc);
 		while (dbresults(dbproc) != NO_MORE_RESULTS) {
 			/* nop */
 		}
 	}
-}				/* create_tables()  */
+}
 
 
 static int
-start_query(DBPROCESS * dbproc, const char *cmd)
+start_query(DBPROCESS * dbproc)
 {
 	int i;
 
-	fprintf(stdout, "%s\n", cmd);
-	if (SUCCEED != dbcmd(dbproc, cmd)) {
+	if (SUCCEED != sql_cmd(dbproc, INPUT)) {
 		return 0;
 	}
 	if (SUCCEED != dbsqlexec(dbproc)) {
@@ -64,7 +56,7 @@ start_query(DBPROCESS * dbproc, const char *cmd)
 		add_bread_crumb();
 	}
 	return 1;
-}				/* start_query()  */
+}
 
 int
 main(int argc, char **argv)
@@ -112,7 +104,7 @@ main(int argc, char **argv)
 
 	create_tables(dbproc, 10);
 
-	if (!start_query(dbproc, "select * from #dblib0007 where i<=5 order by i")) {
+	if (!start_query(dbproc)) {
 		fprintf(stderr, "%s:%d: start_query failed\n", __FILE__, __LINE__);
 		failed = 1;
 	}
@@ -162,7 +154,7 @@ main(int argc, char **argv)
 	expected_error = 20019;
 	dbsetuserdata(dbproc, (BYTE*) &expected_error);
 
-	if (start_query(dbproc, "select * from #dblib0007 where i>=5 order by i")) {
+	if (start_query(dbproc)) {
 		fprintf(stderr, "%s:%d: start_query should have failed but didn't\n", __FILE__, __LINE__);
 		failed = 1;
 	}
@@ -171,7 +163,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/t0007.sql b/src/dblib/unittests/t0007.sql
new file mode 100644
index 0000000..8101406
--- /dev/null
+++ b/src/dblib/unittests/t0007.sql
@@ -0,0 +1,27 @@
+create table #dblib0007 (i int not null, s char(12) not null)
+go
+insert into #dblib0007 values (1, 'row 0000001')
+go
+insert into #dblib0007 values (2, 'row 0000002')
+go
+insert into #dblib0007 values (3, 'row 0000003')
+go
+insert into #dblib0007 values (4, 'row 0000004')
+go
+insert into #dblib0007 values (5, 'row 0000005')
+go
+insert into #dblib0007 values (6, 'row 0000006')
+go
+insert into #dblib0007 values (7, 'row 0000007')
+go
+insert into #dblib0007 values (8, 'row 0000008')
+go
+insert into #dblib0007 values (9, 'row 0000009')
+go
+select * from #dblib0007 where i<=5 order by i
+go
+/*
+ * Second select, should fail: expected_error = 20019
+ */
+select * from #dblib0007 where i>=5 order by i
+go
diff --git a/src/dblib/unittests/t0008.c b/src/dblib/unittests/t0008.c
index d81caab..f054dca 100644
--- a/src/dblib/unittests/t0008.c
+++ b/src/dblib/unittests/t0008.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0008.c,v 1.17 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0008.c,v 1.18 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -159,10 +159,8 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	if (last_read == rows_to_add - 1)
-		printf("dblib okay for %s\n", __FILE__);
-	else
-		fprintf(stderr, "dblib failed for %s last_read %d\n", __FILE__, (int) last_read);
+	fprintf(stdout, "%s %s (last_read: %d)\n", __FILE__, ((last_read != rows_to_add - 1)? "failed!" : "OK"), (int) last_read);
+
 	free_bread_crumb();
 	return (last_read == rows_to_add - 1) ? 0 : 1;
 }
diff --git a/src/dblib/unittests/t0009.c b/src/dblib/unittests/t0009.c
index 22f1cd4..43ebf3d 100644
--- a/src/dblib/unittests/t0009.c
+++ b/src/dblib/unittests/t0009.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0009.c,v 1.15 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0009.c,v 1.16 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -60,19 +60,19 @@ main(int argc, char **argv)
 	add_bread_crumb();
 
 	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib0009 (i int not null, s char(10) not null)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
 	}
 
 	fprintf(stdout, "insert\n");
-	dbcmd(dbproc, "insert into #dblib0009 values (1, 'abcdef')");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
 	}
-	dbcmd(dbproc, "insert into #dblib0009 values (2, 'abc')");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -80,7 +80,7 @@ main(int argc, char **argv)
 
 
 	fprintf(stdout, "select\n");
-	dbcmd(dbproc, "select * from #dblib0009 order by i");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	add_bread_crumb();
 
diff --git a/src/dblib/unittests/t0009.sql b/src/dblib/unittests/t0009.sql
new file mode 100644
index 0000000..c96f7c5
--- /dev/null
+++ b/src/dblib/unittests/t0009.sql
@@ -0,0 +1,8 @@
+create table #dblib0009 (i int not null, s char(10) not null)
+go
+insert into #dblib0009 values (1, 'abcdef')
+go
+insert into #dblib0009 values (2, 'abc')
+go
+select * from #dblib0009 order by i
+go
diff --git a/src/dblib/unittests/t0011.c b/src/dblib/unittests/t0011.c
index 7d0996a..7e2f3b6 100644
--- a/src/dblib/unittests/t0011.c
+++ b/src/dblib/unittests/t0011.c
@@ -6,14 +6,14 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0011.c,v 1.13 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0011.c,v 1.14 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int failed = 0;
 const char long_column[] = "This is a really long column to ensure that the next row ends properly.";
 const char short_column[] = "Short column";
 
-void insert_row(DBPROCESS * dbproc, char *cmd);
+void insert_row(DBPROCESS * dbproc);
 int select_rows(DBPROCESS * dbproc, int bind_type);
 
 int
@@ -43,14 +43,14 @@ main(int argc, char **argv)
 	dbloginfree(login);
 
 	fprintf(stdout, "Dropping table\n");
-	dbcmd(dbproc, "drop table #dblib0011");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
 	}
 
 	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib0011 (i int not null, c1 char(200) not null, c2 char(200) null, vc varchar(200) null)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -58,18 +58,15 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "insert\n");
 
-	sprintf(cmd, "insert into #dblib0011 values (1, '%s','%s','%s')", long_column, long_column, long_column);
-	insert_row(dbproc, cmd);
-	sprintf(cmd, "insert into #dblib0011 values (2, '%s','%s','%s')", short_column, short_column, short_column);
-	insert_row(dbproc, cmd);
-	sprintf(cmd, "insert into #dblib0011 values (3, '%s',NULL,NULL)", short_column);
-	insert_row(dbproc, cmd);
+	insert_row(dbproc);
+	insert_row(dbproc);
+	insert_row(dbproc);
 
 	failed = select_rows(dbproc, STRINGBIND);
 
 	dbexit();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	return failed ? 1 : 0;
 }
 
@@ -84,7 +81,7 @@ select_rows(DBPROCESS * dbproc, int bind_type)
 
 
 	fprintf(stdout, "select\n");
-	dbcmd(dbproc, "select * from #dblib0011 order by i");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 
 
@@ -133,10 +130,9 @@ select_rows(DBPROCESS * dbproc, int bind_type)
 }
 
 void
-insert_row(DBPROCESS * dbproc, char *cmd)
+insert_row(DBPROCESS * dbproc)
 {
-	fprintf(stdout, "%s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
diff --git a/src/dblib/unittests/t0011.sql b/src/dblib/unittests/t0011.sql
new file mode 100644
index 0000000..8771f27
--- /dev/null
+++ b/src/dblib/unittests/t0011.sql
@@ -0,0 +1,12 @@
+drop table #dblib0011
+go
+create table #dblib0011 (i int not null, c1 char(200) not null, c2 char(200) null, vc varchar(200) null)
+go
+insert into #dblib0011 values (1, 'This is a really long column to ensure that the next row ends properly.','This is a really long column to ensure that the next row ends properly.','This is a really long column to ensure that the next row ends properly.')
+go
+insert into #dblib0011 values (2, 'Short column','Short column','Short column')
+go
+insert into #dblib0011 values (3, 'Short column',NULL,NULL)
+go
+select * from #dblib0011 order by i
+go
diff --git a/src/dblib/unittests/t0012.c b/src/dblib/unittests/t0012.c
index 3fe88fa..d7f34ea 100644
--- a/src/dblib/unittests/t0012.c
+++ b/src/dblib/unittests/t0012.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0012.c,v 1.22 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0012.c,v 1.23 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 int failed = 0;
 
@@ -15,8 +15,6 @@ main(int argc, char *argv[])
 {
 	LOGINREC *login;
 	DBPROCESS *dbproc;
-	char cmd[512];
-	char sqlCmd[256];
 	char datestring[256];
 	DBDATEREC dateinfo;
 	DBDATETIME mydatetime;
@@ -45,29 +43,23 @@ main(int argc, char *argv[])
 	fprintf(stdout, "After logon\n");
 
 	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib0012 (dt datetime not null)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) == SUCCEED) {
 		/* nop */
 	}
 
-	sprintf(cmd, "insert into #dblib0012 values ('Feb 27 2001 10:24:35:056AM')");
-	fprintf(stdout, "%s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) == SUCCEED) {
 		/* nop */
 	}
 
-	sprintf(cmd, "insert into #dblib0012 values ('Dec 25 1898 07:30:00:567PM')");
-	fprintf(stdout, "%s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) == SUCCEED) {
 		/* nop */
 	}
-	sprintf(sqlCmd, "SELECT dt FROM #dblib0012");
-	dbcmd(dbproc, sqlCmd);
 	dbsqlexec(dbproc);
 	dbresults(dbproc);
 
@@ -108,7 +100,7 @@ main(int argc, char *argv[])
 	dbclose(dbproc);
 	dbexit();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/t0012.sql b/src/dblib/unittests/t0012.sql
new file mode 100644
index 0000000..29a8f9c
--- /dev/null
+++ b/src/dblib/unittests/t0012.sql
@@ -0,0 +1,8 @@
+create table #dblib0012 (dt datetime not null)
+go
+insert into #dblib0012 values ('Feb 27 2001 10:24:35:056AM')
+go
+insert into #dblib0012 values ('Dec 25 1898 07:30:00:567PM')
+go
+SELECT dt FROM #dblib0012
+go
diff --git a/src/dblib/unittests/t0013.c b/src/dblib/unittests/t0013.c
index c3044a7..06b2396 100644
--- a/src/dblib/unittests/t0013.c
+++ b/src/dblib/unittests/t0013.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0013.c,v 1.27 2008/12/02 10:54:38 freddy77 Exp $";
+static char software_version[] = "$Id: t0013.c,v 1.28 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define BLOB_BLOCK_SIZE 4096
@@ -25,16 +25,12 @@ DBPROCESS *dbproc, *dbprocw;
 static void
 drop_table(void)
 {
-	char cmd[1024];
-
 	if (!dbproc) 
 		return;
 
 	dbcancel(dbproc);
 
-	sprintf(cmd, "drop table " TABLE_NAME);
-	fprintf(stdout, "sql: %s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -52,11 +48,9 @@ main(int argc, char **argv)
 	char *blob, *rblob;
 	DBBINARY *textPtr = NULL, *timeStamp = NULL;
 	char objname[256];
-	char sqlCmd[256];
 	char rbuf[BLOB_BLOCK_SIZE];
 	long numread;
 	BOOL readFirstImage;
-	char cmd[1024];
 	int data_ok;
 #ifdef DBWRITE_OK_FOR_OVER_4K
 	int numtowrite, numwritten;
@@ -112,9 +106,7 @@ main(int argc, char **argv)
 	fread((void *) blob, isiz, 1, fp);
 	fclose(fp);
 
-	sprintf(cmd, "create table " TABLE_NAME " (i int not null, PigTure image not null)");
-	fprintf(stdout, "sql: %s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -122,17 +114,13 @@ main(int argc, char **argv)
 
 	atexit(drop_table);
 
-	sprintf(cmd, "insert into " TABLE_NAME " values (1, '')");
-	fprintf(stdout, "sql: %s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
 	}
 
-	sprintf(sqlCmd, "SELECT PigTure FROM " TABLE_NAME " WHERE i = 1");
-	fprintf(stdout, "sql: %s\n", sqlCmd);
-	dbcmd(dbproc, sqlCmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	if (dbresults(dbproc) != SUCCEED) {
 		fprintf(stderr, "Error inserting blob\n");
@@ -198,10 +186,7 @@ main(int argc, char **argv)
 		dbuse(dbproc, DATABASE);
 	}
 #endif
-	sprintf(cmd, "select i, PigTure from " TABLE_NAME " order by i");
-
-	fprintf(stdout, "sql: %s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 
 	if (dbresults(dbproc) != SUCCEED) {
@@ -236,17 +221,13 @@ main(int argc, char **argv)
 	dbnextrow(dbproc);
 
 	/* get the image */
-	strcpy(sqlCmd, "SET TEXTSIZE 2147483647");
-	fprintf(stdout, "sql: %s\n", sqlCmd);
-	dbcmd(dbproc, sqlCmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	dbresults(dbproc);
 
 	fprintf(stdout, "select 2\n");
 
-	sprintf(sqlCmd, "SELECT PigTure FROM " TABLE_NAME " WHERE i = 1");
-	fprintf(stdout, "sql: %s\n", sqlCmd);
-	dbcmd(dbproc, sqlCmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	if (dbresults(dbproc) != SUCCEED) {
 		fprintf(stderr, "Error extracting blob\n");
@@ -303,6 +284,6 @@ main(int argc, char **argv)
 
 	dbexit();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/t0013.sql b/src/dblib/unittests/t0013.sql
new file mode 100644
index 0000000..9f976c2
--- /dev/null
+++ b/src/dblib/unittests/t0013.sql
@@ -0,0 +1,14 @@
+create table freetds_dblib_t0013 (i int not null, PigTure image not null)
+go
+insert into freetds_dblib_t0013 values (1, '')
+go
+SELECT PigTure FROM freetds_dblib_t0013 WHERE i = 1
+go
+select i, PigTure from freetds_dblib_t0013 order by i
+go
+SET TEXTSIZE 2147483647
+go
+SELECT PigTure FROM freetds_dblib_t0013 WHERE i = 1
+go
+drop table freetds_dblib_t0013
+go
diff --git a/src/dblib/unittests/t0014.c b/src/dblib/unittests/t0014.c
index 96ca83e..9666086 100644
--- a/src/dblib/unittests/t0014.c
+++ b/src/dblib/unittests/t0014.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0014.c,v 1.28 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0014.c,v 1.29 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define BLOB_BLOCK_SIZE 4096
@@ -85,14 +85,14 @@ main(int argc, char **argv)
 
 	/* FIXME this test seem to not work using temporary tables (sybase?)... */
 	fprintf(stdout, "Dropping table\n");
-	dbcmd(dbproc, "if object_id('dblib0014') is not null drop table dblib0014");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
 	}
 
 	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table dblib0014 (i int not null, PigTure image not null)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -103,9 +103,8 @@ main(int argc, char **argv)
 	for (i = 0; i < rows_to_add; i++) {
 	char cmd[1024];
 
-		sprintf(cmd, "insert into dblib0014 values (%d, '')", i);
 		fprintf(stdout, "%s\n", cmd);
-		dbcmd(dbproc, cmd);
+		sql_cmd(dbproc, INPUT);
 		dbsqlexec(dbproc);
 		while (dbresults(dbproc) != NO_MORE_RESULTS) {
 			/* nop */
@@ -113,8 +112,7 @@ main(int argc, char **argv)
 	}
 
 	for (i = 0; i < rows_to_add; i++) {
-		sprintf(sqlCmd, "SELECT PigTure FROM dblib0014 WHERE i = %d", i);
-		dbcmd(dbproc, sqlCmd);
+		sql_cmd(dbproc, INPUT);
 		dbsqlexec(dbproc);
 		if (dbresults(dbproc) != SUCCEED) {
 			fprintf(stderr, "Error inserting blob\n");
@@ -159,7 +157,7 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "select\n");
 
-	dbcmd(dbproc, "select * from dblib0014 order by i");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 
 	if (dbresults(dbproc) != SUCCEED) {
@@ -250,7 +248,7 @@ main(int argc, char **argv)
 	free(blob);
 
 	fprintf(stdout, "Dropping table\n");
-	dbcmd(dbproc, "drop table dblib0014");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
diff --git a/src/dblib/unittests/t0014.sql b/src/dblib/unittests/t0014.sql
new file mode 100644
index 0000000..7d1d96c
--- /dev/null
+++ b/src/dblib/unittests/t0014.sql
@@ -0,0 +1,20 @@
+if object_id('dblib0014') is not null drop table dblib0014
+go
+create table dblib0014 (i int not null, PigTure image not null)
+go
+insert into dblib0014 values (0, '')
+go
+insert into dblib0014 values (1, '')
+go
+insert into dblib0014 values (2, '')
+go
+SELECT PigTure FROM dblib0014 WHERE i = 0
+go
+SELECT PigTure FROM dblib0014 WHERE i = 1
+go
+SELECT PigTure FROM dblib0014 WHERE i = 2
+go
+select * from dblib0014 order by i
+go
+drop table dblib0014
+go
diff --git a/src/dblib/unittests/t0015.c b/src/dblib/unittests/t0015.c
index ba8a3b8..16d8176 100644
--- a/src/dblib/unittests/t0015.c
+++ b/src/dblib/unittests/t0015.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0015.c,v 1.18 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0015.c,v 1.19 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -55,7 +55,7 @@ main(int argc, char **argv)
 	add_bread_crumb();
 
 	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib0015 (i int not null, s char(10) not null)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -63,11 +63,7 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "insert\n");
 	for (i = 0; i < rows_to_add; i++) {
-	char cmd[1024];
-
-		sprintf(cmd, "insert into #dblib0015 values (%d, 'row %03d')", i, i);
-		fprintf(stdout, "%s\n", cmd);
-		dbcmd(dbproc, cmd);
+		sql_cmd(dbproc, INPUT);
 		dbsqlexec(dbproc);
 		while (dbresults(dbproc) != NO_MORE_RESULTS) {
 			/* nop */
@@ -75,7 +71,7 @@ main(int argc, char **argv)
 	}
 
 	fprintf(stdout, "select\n");
-	dbcmd(dbproc, "select * from #dblib0015 order by i");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	add_bread_crumb();
 
@@ -119,7 +115,7 @@ main(int argc, char **argv)
 	dbcancel(dbproc);
 
 	fprintf(stdout, "select 2\n");
-	dbcmd(dbproc, "select * from #dblib0015 where i > 25 order by i");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 
 	if (dbresults(dbproc) != SUCCEED) {
@@ -179,7 +175,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/t0015.sql b/src/dblib/unittests/t0015.sql
new file mode 100644
index 0000000..6e3f2a0
--- /dev/null
+++ b/src/dblib/unittests/t0015.sql
@@ -0,0 +1,106 @@
+create table #dblib0015 (i int not null, s char(10) not null)
+go
+insert into #dblib0015 values (0, 'row 000')
+go
+insert into #dblib0015 values (1, 'row 001')
+go
+insert into #dblib0015 values (2, 'row 002')
+go
+insert into #dblib0015 values (3, 'row 003')
+go
+insert into #dblib0015 values (4, 'row 004')
+go
+insert into #dblib0015 values (5, 'row 005')
+go
+insert into #dblib0015 values (6, 'row 006')
+go
+insert into #dblib0015 values (7, 'row 007')
+go
+insert into #dblib0015 values (8, 'row 008')
+go
+insert into #dblib0015 values (9, 'row 009')
+go
+insert into #dblib0015 values (10, 'row 010')
+go
+insert into #dblib0015 values (11, 'row 011')
+go
+insert into #dblib0015 values (12, 'row 012')
+go
+insert into #dblib0015 values (13, 'row 013')
+go
+insert into #dblib0015 values (14, 'row 014')
+go
+insert into #dblib0015 values (15, 'row 015')
+go
+insert into #dblib0015 values (16, 'row 016')
+go
+insert into #dblib0015 values (17, 'row 017')
+go
+insert into #dblib0015 values (18, 'row 018')
+go
+insert into #dblib0015 values (19, 'row 019')
+go
+insert into #dblib0015 values (20, 'row 020')
+go
+insert into #dblib0015 values (21, 'row 021')
+go
+insert into #dblib0015 values (22, 'row 022')
+go
+insert into #dblib0015 values (23, 'row 023')
+go
+insert into #dblib0015 values (24, 'row 024')
+go
+insert into #dblib0015 values (25, 'row 025')
+go
+insert into #dblib0015 values (26, 'row 026')
+go
+insert into #dblib0015 values (27, 'row 027')
+go
+insert into #dblib0015 values (28, 'row 028')
+go
+insert into #dblib0015 values (29, 'row 029')
+go
+insert into #dblib0015 values (30, 'row 030')
+go
+insert into #dblib0015 values (31, 'row 031')
+go
+insert into #dblib0015 values (32, 'row 032')
+go
+insert into #dblib0015 values (33, 'row 033')
+go
+insert into #dblib0015 values (34, 'row 034')
+go
+insert into #dblib0015 values (35, 'row 035')
+go
+insert into #dblib0015 values (36, 'row 036')
+go
+insert into #dblib0015 values (37, 'row 037')
+go
+insert into #dblib0015 values (38, 'row 038')
+go
+insert into #dblib0015 values (39, 'row 039')
+go
+insert into #dblib0015 values (40, 'row 040')
+go
+insert into #dblib0015 values (41, 'row 041')
+go
+insert into #dblib0015 values (42, 'row 042')
+go
+insert into #dblib0015 values (43, 'row 043')
+go
+insert into #dblib0015 values (44, 'row 044')
+go
+insert into #dblib0015 values (45, 'row 045')
+go
+insert into #dblib0015 values (46, 'row 046')
+go
+insert into #dblib0015 values (47, 'row 047')
+go
+insert into #dblib0015 values (48, 'row 048')
+go
+insert into #dblib0015 values (49, 'row 049')
+go
+select * from #dblib0015 order by i
+go
+select * from #dblib0015 where i > 25 order by i
+go
diff --git a/src/dblib/unittests/t0016.c b/src/dblib/unittests/t0016.c
index 5c966bd..8847562 100644
--- a/src/dblib/unittests/t0016.c
+++ b/src/dblib/unittests/t0016.c
@@ -6,7 +6,7 @@
 #include "common.h"
 #include <sys/stat.h>
 
-static char software_version[] = "$Id: t0016.c,v 1.27 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0016.c,v 1.28 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int failed = 0;
@@ -82,9 +82,7 @@ main(int argc, char *argv[])
 	printf("After logon\n");
 
 	printf("Creating table '%s'\n", TABLE_NAME);
-	strcpy(sqlCmd, "create table #dblib0016 (f1 int not null, s1 int null, f2 numeric(10,2) null, ");
-	strcat(sqlCmd, "f3 varchar(255) not null, f4 datetime null) ");
-	dbcmd(dbproc, sqlCmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -99,7 +97,7 @@ main(int argc, char *argv[])
 
 	printf("return from bcp_init = %d\n", ret);
 
-	ret = dbcmd(dbproc, "select * from #dblib0016 where 0=1");
+	ret = sql_cmd(dbproc, INPUT);
 	printf("return from dbcmd = %d\n", ret);
 
 	ret = dbsqlexec(dbproc);
@@ -141,7 +139,7 @@ main(int argc, char *argv[])
 		failure("bcp_int failed\n");
 
 	printf("select\n");
-	dbcmd(dbproc, "select * from #dblib0016 where 0=1");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 
 	if (dbresults(dbproc) != FAIL) {
diff --git a/src/dblib/unittests/t0016.sql b/src/dblib/unittests/t0016.sql
new file mode 100644
index 0000000..279987d
--- /dev/null
+++ b/src/dblib/unittests/t0016.sql
@@ -0,0 +1,6 @@
+create table #dblib0016 (f1 int not null, s1 int null, f2 numeric(10,2) null, f3 varchar(255) not null, f4 datetime null) 
+go
+select * from #dblib0016 where 0=1
+go
+select * from #dblib0016 where 0=1
+go
diff --git a/src/dblib/unittests/t0017.c b/src/dblib/unittests/t0017.c
index d7cb459..4b12456 100644
--- a/src/dblib/unittests/t0017.c
+++ b/src/dblib/unittests/t0017.c
@@ -6,7 +6,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: t0017.c,v 1.27 2006/08/25 09:04:18 freddy77 Exp $";
+static char software_version[] = "$Id: t0017.c,v 1.28 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int failed = 0;
@@ -68,14 +68,14 @@ main(int argc, char *argv[])
 	printf("done\n");
 
 	printf("Creating table ... ");
-	dbcmd(dbproc, "create table #dblib0017 (c1 int null, c2 text)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
 	}
 	printf("done\n");
 
-	dbcmd(dbproc, "insert into #dblib0017(c1,c2) values(1144201745,'prova di testo questo testo dovrebbe andare a finire in un campo text')");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -89,7 +89,7 @@ main(int argc, char *argv[])
 	printf("done\n");
 
 	printf("Issuing SELECT ... ");
-	dbcmd(dbproc, "select * from #dblib0017 where 0=1");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	printf("done\nFetching metadata ... ");
 	if (dbresults(dbproc) != FAIL) {
@@ -132,7 +132,7 @@ main(int argc, char *argv[])
 	printf("%d rows copied\n", rows_copied);
 
 	/* delete rows */
-	dbcmd(dbproc, "delete from #dblib0017");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -148,7 +148,7 @@ main(int argc, char *argv[])
 	printf("done\n");
 
 	printf("Issuing SELECT ... ");
-	dbcmd(dbproc, "select * from #dblib0017 where 0=1");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	printf("done\nFetching metadata ... ");
 	if (dbresults(dbproc) != FAIL) {
@@ -194,7 +194,7 @@ main(int argc, char *argv[])
 
 	/* test we inserted correctly row */
 	if (!failed) {
-		dbcmd(dbproc, "SET NOCOUNT ON DECLARE @n INT SELECT @n = COUNT(*) FROM #dblib0017 WHERE c1=1144201745 AND c2 LIKE 'prova di testo questo testo dovrebbe andare a finire in un campo text' IF @n <> 1 SELECT 0");
+		sql_cmd(dbproc, INPUT);
 		dbsqlexec(dbproc);
 		while (dbresults(dbproc) != NO_MORE_RESULTS) {
 			while ((ret=dbnextrow(dbproc)) != NO_MORE_ROWS) {
diff --git a/src/dblib/unittests/t0017.sql b/src/dblib/unittests/t0017.sql
new file mode 100644
index 0000000..7a75f53
--- /dev/null
+++ b/src/dblib/unittests/t0017.sql
@@ -0,0 +1,12 @@
+create table #dblib0017 (c1 int null, c2 text)
+go
+insert into #dblib0017(c1,c2) values(1144201745,'prova di testo questo testo dovrebbe andare a finire in un campo text')
+go
+select * from #dblib0017 where 0=1
+go
+delete from #dblib0017
+go
+select * from #dblib0017 where 0=1
+go
+SET NOCOUNT ON DECLARE @n INT SELECT @n = COUNT(*) FROM #dblib0017 WHERE c1=1144201745 AND c2 LIKE 'prova di testo questo testo dovrebbe andare a finire in un campo text' IF @n <> 1 SELECT 0
+go
diff --git a/src/dblib/unittests/t0018.c b/src/dblib/unittests/t0018.c
index 8b5bd82..6f5febc 100644
--- a/src/dblib/unittests/t0018.c
+++ b/src/dblib/unittests/t0018.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0018.c,v 1.19 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0018.c,v 1.20 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -55,7 +55,7 @@ main(int argc, char **argv)
 	add_bread_crumb();
 
 	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib0018 (i int not null, s char(10) not null)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -63,11 +63,7 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "insert\n");
 	for (i = 0; i < rows_to_add; i++) {
-	char cmd[1024];
-
-		sprintf(cmd, "insert into #dblib0018 values (%d, 'row %03d')", i, i);
-		fprintf(stdout, "%s\n", cmd);
-		dbcmd(dbproc, cmd);
+		sql_cmd(dbproc, INPUT);
 		dbsqlexec(dbproc);
 		while (dbresults(dbproc) != NO_MORE_RESULTS) {
 			/* nop */
@@ -80,7 +76,7 @@ main(int argc, char **argv)
 	}
 
 	fprintf(stdout, "select\n");
-	dbcmd(dbproc, "select * into #tmp0 from #dblib0018\nselect * from #tmp0 order by i");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	add_bread_crumb();
 
@@ -170,7 +166,7 @@ main(int argc, char **argv)
 		exit(1);
 	}
 
-	dbcmd(dbproc, "update #dblib0018 set s = 'row 000'");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	add_bread_crumb();
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
@@ -188,7 +184,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
